PROGRAM TMODEM;  {TURBO_Modem}
{$R-}
{$S-}
{$V-}
{$B+}
{$D+,L+}
{$M 18000, 4096,40960}      {2.24}

USES Dos,Crt,Common,Wind,Ansi;  { 2.23 }

(* --------------------------------------------------
  Written by Jack M. Wierda  Chicago Illinois
  Modified by Steve Freeman
  From 6 JAN 86 mods by L.B. Neal

  2-25-87 Still not complete but a improvements made
  and a core of concepts for someone to go
  further.
  l.b. Neal - Sunnyvale,CA

  UPGRADES:
  1.  Increase communications options.
  3.  Adjustable text mode and colors.

  11-26-88 Ver: 1.1

  1. Major loop restructure. - ok -
  2. Added 2400 baud.        - ok -
  3. Added:                  - ok -
     a. HOME = Help
     b. PgUp = Upload
     c. PgDn = Download
     d. ALT-X = EXIT TModem
     e. ALT-O = Options.
     f. ALT-S = Screen Colors
     g. ALT-H = Hangup
     h. ALT-I = TModem Information.
  4. Window for functions.     - ok -
  5. Adjusted XMODEM DL for longer interface time.  - problems! -
  6. Allowed TModem to receive full "IBM" ASCII char set. - ok -
  7. TModem now recognizes <FF> for ClrScr.         - ok -
  8. Added status line on bottom of screen.         - ok -
  9. Big choice of colors - screen and status line. - ok -

  11-28-88 Ver: 1.2

  1. A little more speed  -  adjusted LiveTerminal main loop.
  2. COM2: still refuses to receive, transmit seems ok. { Working at it. }
  3. XMODEM receive now seems ok.
  4. HANGUP doesn't work real well.

  11-29-88 Ver: 1.3

  1. Fixed exit sequence.

  12-01-88 1.4

  1. Added Configuration file TMODEM.CFG - colors and COMM info.

  12-12-88 1.5

  1. Got the dialing dir to work.
  2. Can save phone numbers to TMODEM.PHN
  3. Can't delete numbers from TMODEM.PHN

  04-11-89 1.6
  1. Clean up a few oops!
  2. More work on Auto-dialing may be better now.
  3. Tried to resolve hangup problem.
  4. Added modem initialization. ( See PROCEDURE ResetModem )
  5. Changed the interface when doing auto-dial.

  LANGUAGE: TURBO Pascal 3.01A or 3.02a.
  This program is in the public domain.

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  09-26-89 2.0c
  1. Convert to TURBO Pascal 5.0!
  2. Comm port 1,2,3,4 supported.
  3. 300 thru 9600 baud supported.
  4. External Protocol Support.
  5. J)ump to DOS added.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  09-27-89 2.0d/2.0e
   1. Fixed screen arrow garbage.
   2. Fixed EXIT dial routine.
   3. General cleanup.
   4. More speed.
   5. Fixed JUMPDOS.BAT.
   6. Changed timing.
   7. Added modem init string to TMODEM.CFG.

  09-28-89 2.0f
   1. Added verification of quit TModem.
   2. Modified status line.
   3. Moved windows further away from main screen.
   4. Added SmallWindow.
   5. Deleted ANS mode.

  09-28-89 2.0g
   1. Corrected screen change menu.

  09-30-89 2.0h
   1. Added user clearscreen option. ( For my goofs! )
   2. Optimized Terminal loop.
   3. Increased wait for connect time.
   4. Faster windows.
   5. Added abort for connect wait.
   6. Show name calling when dialing.
   7. Can clear or modify entry in dialing directory.

  10-01-89 2.0i
   1. Added F1-F10 macro capability - see MACRO.DOC!!
   2. Corrected modem speed initialization.
   3. Modem speed changes when dialing.
   4. Adjusted Help Screen.
   5. Change options will change baud!

  10-01-89 2.0j
   1. Added ANSI support. ANSI.SYS required!!!
   2. Added ANSI status to statusline.

  10-01-89 2.0k
   1. Cleanup after ANSI.

  10-01-89 2.0l
   1. More ANSI side-effect cleanup.

  10-02-89 2.0m
   1. More attention to ANSI/NON-ANSI states.
   2. Added ALT-V to View statusline.
   3. Fixed ANSI-BBS ClrScr with help K. Burkhart.
   4. Rearranged HELP screen.

  10-03-89 2.0n
   1. Added Dial String to TModem.cfg.
   2. Fixed C)rcXmodem call to XMx.BAT.

  10-03-89 2.0o
   1. Improved ANSI tracking scheme for triggering on cursor color.
   2. Better screen clear before dialing.
   3. Deleted TMODEM.CFG from ZIP and set defaults to test for video
      card and set accordingly. Also COM1: and 1200 baud default.

  10-04-89 2.0p
   1. Better return from windows. (Finally!).

  10-06-89 2.0q
   1. Address video mode on Exit TModem.
   2. Single "A" to abort dialing.
   3. Issue message and kick modem if abort.
   4. Better tracking in ANSI mode.
   5. Smaller memory requirements.
   6. DirectVideo or BIOS option for screen.

  10-09-89 2.0r
   1. New protocol selection window.
   2. Added TallWindow procedure.
   3. Corrected roblem with protocol procedure.
   4. Changed filename winddow to smallwindow.

  10-18-89 2.0s
   1. Made R- and S- global.
   2. Moved Send( into ssendtext( for even more speed.
   3. Improved the TMODEM.CFG format. Old config will still read.
      - IF TMODEM.CFG is NOT found a new format TMODEM.CFG will be created.
   4. Toggle of ANSI in either direction will display statusline.
   5. Improved dialing and hangup sequences.
   6. Added ONLINE/OFFLINE to statusline.

  10-19-89 2.0t
   1. Cleanup ALT-S function, now a little bullet-proofing added.
   2. Improved ONLINE/OFFLINE detect.
   3. Added videomode to ALT-S.
   4. Startup announces the current videomode and CPU speed.
   5. Added CPU speed support routines for delay = Sdelay;
   6. New line for TMODEM.CFG! CPUSPEED=
  
  01-7-90 2.0u
   1. More efforts at correcting screen on exit.
   2. Answer 'y' to exit question prints "Yes".
   
  01-8-90 2.0v
   1. Better ONLINE status.

  01-14-90 2.0w
   1. New simplified screen border routine.

  01-26-90 2.0x
   1. Added support for PUMA file protocol.   

  03-26-90 2.10
   1. Tmodem now uses Turbo Pascal Fast Library(TPFL) and WINDSAVE.

      Windsave allows saving the image behind a window and then restoring
      it and the previous window upon closing the window. The windows can
      be 10 levels deep!

   NOTE: Windsave is based on the Program Wind2 from the book
         "USING TURBO PASCAL" by Michael Yester, Published by QUE.
         I therefore CANNOT supply the source for WINDSAVE. IF you
         are using Turbo Pascal 4.0 or higher I suggest this book
         as a superb reference.
         I have added some "bulletproofing" to the original code as it
         did NOT try to protect itself from impossible inputs.


         TPFL is my own "cheap" shareware package for speeding up
         TP 5.0/5.5 programs and so the source is NOT presented here.
         Permission is granted to use TPFL5.TPU in conjunction with
         TMODEM.PAS for personal use without registration of TPFL.


   2. Removed usage of TURBO3 unit.


  04-24-90 2.12
   1. Windsave no longer used.

  08-11-90 2.13
   1. Addressed proper color on return from ansi.   
   2. Corrected intvector sequence at end of TMODEM.

  10-01-90 2.14
   1. Added Missing Far Directives. 
   2. Made Fiename variable string[22] was [20].

  10-03-90 2.15
   1. Removed SDELAY Procedure NOT needed TP5+.
   2. Removed Delay_Calc, cpuspeed and all references to those.

  10-23-90 2.16 
   1. Went back to WIND.TPU (see 2.10 notes!).

  12-28-90 2.17
   1. Added code to inform DOS of COM3 & COM4.
   2. Added Boolean test for incoming bytes.

  02-09-91 2.18
   1. Included windtp.zip which has source for the now used
      wind.tpu.

  08-23-91 2.19

   See readme.219

  09-06-91 2.20

   See readme.220

  10-27-92 2.24

    NOTE: There are many places available to optimize TMODEM. I see
          them go by, but leave them for you to find. Many simple
          changes in construct will result in overall speed increases.
          Most changes will also reduce the size of tmodem.exe.

  This program was basically a re-write in TURBO Pascal of Ward Christensen's
  Modem Program which was distributed in CP/M User's Group Volume 25. Identical
  and compatible options were provided to allow this program to work directly
  with XMODEM running under CP/M.
 ----------------------------------------------------------------------- *)

 PROCEDURE set_baud(r:integer);
 VAR a: byte; rw: word;
 BEGIN
  IF (r >= 300) AND (r <= 19200) THEN {2.23}
   BEGIN
    CASE r OF {2.22}
     2400 : rw := 48;
     1200 : rw := 96;
     4800 : rw := 24; {2.22}
     9600 : rw := 12; {2.21}
    19200 : rw := 6;  {2.23}
      300 : rw := 384;
    END;
    a := port[base+3] OR 128;
    port[base+3] := a;
    port[base] := lo(rw);
    port[base+1] := hi(rw);
    port[base+3] := a AND 127;
   END
  ELSE
   BEGIN
    Writeln('Invalid Baud Rate = ', r); { 2.0i }
    Halt(1);
   END;
 END;

 {$F+} {2.14 This procedure MUST be FAR!}
 PROCEDURE async_isr; Interrupt;{$F-} {2.23}
  BEGIN
   Inline($FB); {STI 2.20 corrected to let other interrupts occur}
   RecBuf[Buffer_Head] := Char(Port[Base]);
   IF (Buffer_Head = Buffer_End) THEN Buffer_Head := 1 ELSE INC(Buffer_Head);
   Port[$20] := $20;  {tell CPU that interrupt is finished}
   INready := True;    {8-15-92}
   INC(Buffer_Count);  {8-15-92}
  END;

 procedure dump;
 begin
  Inline($FA); {CLI}
  buffer_head := 1;
  buffer_tail := 1;
  buffer_count := 0;
  Inready := False; {2.17}
  Inline($FB); {STI}
  Port[$20] := $20; {2.19}
 end;

 procedure remove_port;
 var i,m : Word;
 begin
  inline($FA); {CLI}
  i := port[$21];
  m := 1 SHL Async_Irq;
  port[$21] := i OR m;
  port[base+2] := 0;
  port[base+4] := port[base+4] AND 1;
  inline($FB); {STI}
  Port[$20] := $20; {2.19}
 end;

 procedure term_ready(s:Boolean);
 var x:byte;
 begin
  x := port[base+4] and $FE;
  if s then x := x+1;
  port[base+4] := x;
 end;

 PROCEDURE iport1;
  BEGIN
   CASE comport OF
   1 : begin
        base := $3f8; Async_Irq  := 4; cport := 'COM1:';
       end;
   2 : begin
        base := $2f8; Async_Irq  := 3; cport := 'COM2:';
       end;
   3 : begin
        base := $3E8; Async_Irq  := 4; cport := 'COM3:';
       end;
   4 : begin
        base := $2E8; Async_Irq  := 3; cport := 'COM4:';
       end;
   END;
   outport := Base+5;
   cdetport := Base+6; {2.20}
  END;

 procedure iport;
 var i,m:Integer;
 BEGIN
  {dsaves := DSeg;} {2.19}
(* ------   problems with 16550 here! 2.19
  If (Port[2+base] and $00F8) <> 0 Then
   begin
    writeln('Illegal com port number:',cport);
    halt;
   end
  else
   begin
 --------- *)
    buffer_Head := 1;
    buffer_Tail := 1;
    buffer_Count := 0;
    Inready := False;    {2.17}
    port[base+3] := $03;
    with regs do
     begin
      ah := $25;
      al := async_irq+8;
      ds := cseg;
      dx := ofs(async_isr);
      msdos(regs);
     end;
    inline($FA);
    i := port[5+base];
    i := port[base];
    i := port[$21];
    m := (1 shl Async_Irq) xor $00FF;
    port[$21] := i and m;
    port[1+base] := $01;
    i := port[4+base];
    port[4+base] := i or $0B;{ $08; 2.22}
    term_ready(true);
    inline($FB);
    Port[$20] := $20; {2.19}
   {end;} {2.19}
 end;

(* --------------------------------------------------------------
  Deleted 2.15 NOT needed w/TP5+ compiler calculates real value!

 PROCEDURE SDELAY(Ms: Word);   { 2.0t }
 VAR delay_actual: Word;
  BEGIN
   Delay_Actual := Round(delay_calc * ms);
   DELAY(Delay_Actual);
  END;
 ----------------------- *)

  FUNCTION value(i:str2):integer; Forward; {2.25}

(* -----
  FUNCTION Cts: Boolean;
  BEGIN
    Cts := (Port[cdetport] AND $10) <> 0; {2.20}
  END;
 ------- *)

  FUNCTION Cinkey:char;
  VAR t:char;
  BEGIN
   IF NOT Inready THEN
     cinkey := #0 {2.19}
   ELSE
    BEGIN
     inline($FA);
     cinkey := RecBuf[buffer_Tail];
     IF Buffer_Tail < Buffer_End THEN INC(Buffer_Tail) ELSE Buffer_Tail := 1;
     DEC(buffer_count);
     IF Buffer_Count = 0 THEN Inready := False; {2.17}
     inline($FB);
     Port[$20] := $20; {2.19}
    END;
   {cinkey := chr(ord(t));} { 2.19}
   {cinkey := t;} {2.19}
  END;

  PROCEDURE sendtext(Strg: Str90 ); {2.23 modified and moved here}
  VAR i,size,cnt,sendc: byte; {2.23}
  BEGIN
   Size := ord(strg[0]);
   FOR i := 1 TO size DO
    BEGIN
     IF strg[i] <> '~' THEN {2.23}
      BEGIN
       REPEAT UNTIL Cts; {2.20}
       sendc := ord(strg[i]); {2.23}
       WHILE (port[outport] AND 32) = 0 DO {NOP}; {2.21}
       port[base] := sendc; {2.23}
       delay(5); {2.22}
       IF InReady THEN Write(CinKey); {2.23}
      END
     ELSE
      Delay(250); {2.23}
    END;
   IF sendc = 13 THEN Delay(1000); {2.23}
   WHILE InReady DO Write(CinKey);
  END;

  PROCEDURE init1; { 2.0t }
  VAR maxbaud, stat : Integer;
  BEGIN
   val(speed,maxbaud,stat); { 2.0i }
   Set_Baud(maxbaud);
   delay(600); { 2.15 }
   sendtext('AT'+cr);
   {delay(1000);} {2.23}
   {dump;} {2.23}
  END;

 function commpressed: boolean;
 begin
  commpressed := Inready; {2.17}
 end;


(* ------ NOT used in TModem but left as an example -------

  FUNCTION hex(num : Integer) : hexstr;
  VAR i, j : Integer; h : STRING[16]; Str : hexstr;
  BEGIN
   Str := '0000'; h := '0123456789ABCDEF'; j := num;
   FOR i := 4 DOWNTO 1 DO
    BEGIN
     Str[i] := h[(j AND 15)+1];
     j := j SHR 4;
    END;
   hex := Str;
  END;
------------------------------------------------------------ *)

  FUNCTION value(i:str2):integer; {2.25}
  VAR n,n1:integer;
  BEGIN
   val(i,n,n1);
   IF n1 <> 0 THEN
    BEGIN
     i := Copy(i,1,n1-1); {2.16}
     val(i,n,n1)
    END;
   value := n;
   IF i = '' THEN value := 0;
  END;

  PROCEDURE StatusLine;  Forward;

   PROCEDURE JUMPDOS; { 2.0c }
    BEGIN
     Windo(1,1,80,25); { 2.23}
     ClrScr;
     mcol := WhereX; mrow := WhereY;
     writeln;  { 2.0q }
     writeln('Drop to DOS!'); { 2.0h }
     writeln('CAUTION: You MUST Exit from shell in TModem home directory!');
     write('Hit a key to continue!');
     REPEAT UNTIL Keypressed;
     ClrScr;
     SwapVectors;
     EXEC(GetEnv('comspec'),'/C JUMPDOS.BAT');
     SwapVectors;
     iport;
     ClrScr; {2.16}
     statusline;
     {GotoXY(mcol,mrow);} {2.16}
    END;

  PROCEDURE FileShell(efn: filename; meth, way: char); { 2.0c }
   VAR theway : filename; passdata : Str90; sport : Char;
   BEGIN
    CASE meth OF
     'K': theway := 'K';
     'M': theway := 'ML';
     'J': theway := 'JM';
     'T': theway := 'TY';
     'W': theway := 'WX';
     'X': theway := 'XM';
     'Y': theway := 'YM';
     'Z': theway := 'ZM';
     'B': theway := 'BI';
     'L': theway := 'LM';
     'S': theway := 'SK';
     'P': theway := 'PU'; { 2.0x }
    END;
    theway := theway+way+'.BAT';
    sport := chr(comport+48);
    passdata:= theway+' '+speed+' '+sport+' '+efn;
    EXEC(GetEnv('comspec'),'/C '+passdata);
    delay(1000);{ 2.15 }
    iport;    
   END;

(* ------------------  Now using WinBorder from TPFL
  PROCEDURE DoBorder(FstCol,FstRow,LstCol,LstRow : Integer);
  VAR i,thisrow,width,height,column: Integer; { 2.0w }
      horiz: Str90; { 2.11 }
  BEGIN
    ClrScr; { 2.11 }
    thisrow := 2;
    width := (LstCol - FstCol) - 1;  { 2.11 }
    height := (LstRow - FstRow)- 1;
    column := Width+2; { 2.11 }
   
    FOR i := 1 to width DO horiz[i] := #205;
    horiz[0] := Char(width);

    Gotoxy(1,1); Write(Chr(201));
    Write(horiz);
    Write(Chr(187));

    FOR i := 1 TO height DO
     BEGIN
      Gotoxy(1,thisrow);       Write(Chr(186));
      Gotoxy(column,thisrow);  Write(Chr(186));
      INC(thisrow);
     END;

    Gotoxy(1,thisrow); Write(CHR(200));
    Write(horiz);
    Write(#188);
  END;
 ----------------------------------------- *)

  PROCEDURE termscrn;  { 2.0m }
  BEGIN
   mcol := WhereX; mrow := WhereY; { 2.0p }
   OpenW(20,09,60,21);  { 2.16 }
   GotoXY(3,2);  Write('         -- TModem Help --          ');
   {Gotoxy(3,3);  Write('                                    ');} {2.35}
   GotoXY(3,4);  Write(' Upload   = PgUp   Download = PgDn  ');
   Gotoxy(3,5);  Write(' Dial     = ALT-D  Hangup   = ALT-H ');
   Gotoxy(3,6);  Write(' Options  = ALT-O  Macros   = F1/F10');
   Gotoxy(3,7);  Write(' Clrscrn  = ALT-C  Info     = ALT-I ');
   Gotoxy(3,8);  Write(' ViewStat = ALT-V  ScrnChg  = ALT-S ');
   Gotoxy(3,9);  Write(' ResetMdm = ALT-R  ANSI Tgl = ALT-A ');
   {Gotoxy(3,10); WriteLn;} {2.23}
   Gotoxy(3,10); Write(' JumpDos  = ALT-J  EXIT     = ALT-X ');
   REPEAT UNTIL Keypressed;
   junk := ReadKey;
   CloseW; { 2.16 }
   GotoXY(mcol,mrow);
  END;

  PROCEDURE SetDTR;
  BEGIN
   Port[base+4] := $09;      { $3FC/$2FC DTR on and INT enabled}
   Delay(500); {2.23}
  END;

  PROCEDURE HangUpPhone;      {hang up by terminating the line}
  BEGIN
   Port[base+4] := 0;
   callout := False;
  END;

  PROCEDURE setup(brc :Char); Forward;   { 1.1 }

  PROCEDURE HangItUp;      { 1.6 }
  BEGIN
   writeln;
   writeln('Hanging up modem!');
   sendtext('+++');
   delay(1000);            { 2.15 }
   sendtext('ATH'+cr);     { 1.6 }
   Setup(baudrate);
   writeln;           { 2.0s }
   sendtext('AT'+cr); { 2.0s }
   mcol := WhereX; mrow := WhereY;
   Statusline;        {2.0s }
  END;

(* -----------  part of sendtext( 2.0s --------
  PROCEDURE send(ch : Char);
  BEGIN
   WHILE (port[outport] AND 32) = 0 DO BEGIN END;
   port[base] := ord(ch);
  END;
 --------------------------------- *)

  PROCEDURE ResetModem;
   BEGIN
    sendtext(initstrg+cr);
   END;

  PROCEDURE XlateSetup;
   BEGIN
    CASE baudrate OF
      '1' : speed := '1200';
      '2' : speed := '2400';
      '3' : speed := ' 300';
      '9' : speed := '9600';
      '4' : speed := '4800';
      '8' : speed := '19200'; {2.23}
    END;
    CASE comport OF
      1 : cport := 'COM1:';
      2 : cport := 'COM2:';
      3 : cport := 'COM3:';
      4 : cport := 'COM4:';
    END;
    IF useansi THEN ansistat := 'Off' ELSE ansistat := ' On'; { 2.0j }
   END;

  PROCEDURE setup(brc :Char); { 1.1 major changes for statusline info }
  BEGIN
    baudrate := brc;
    CASE baudrate OF {2.23}
     '1': speed := '1200';
     '2': speed := '2400';
     '3': speed := ' 300';
     '9': speed := '9600';
     '4': speed := '4800';
     '8': speed := '19200'; {2.23}
    END;

    CASE comport OF
      1 : cport := 'COM1:';
      2 : cport := 'COM2:';
      3 : cport := 'COM3:';
      4 : cport := 'COM4:';
    END;
   init1; {2.0i}
  END;

  PROCEDURE MakeConfig;    { major surgery 2.0s }
  VAR fil : Text;
   BEGIN
    Assign(fil, 'TMODEM.CFG');
    {$I-} Rewrite(fil); {$I+}
    IF IORESULT <> 0 THEN
     BEGIN
      Write('OOPS! TModem Error making TMODEM.CFG.');
      {$I-} Close(fil);{$I+}
      err := IORESULT;
      Halt;
     END;
    Append(fil);
    CASE comport OF
      1 : cport := 'COM1:';
      2 : cport := 'COM2:';
      3 : cport := 'COM3:';
      4 : cport := 'COM4:';
    END;
    Writeln(fil,'PORT=',cport);
    CASE baudrate OF
      '1' : speed := ' 1200';
      '2' : speed := ' 2400';
      '3' : speed := '  300';
      '4' : speed := ' 4800'; {3-26-92}
      '9' : speed := ' 9600';
      '8' : speed := '19200'; {2.23}
    END;
    Writeln(fil, 'BAUD=',speed);    { 2.0s }
    Writeln(fil, 'SCRMODE=',scrmode);
    Writeln(fil, 'TEXTCLR=',txtclr);
    Writeln(fil, 'TEXTBACK=',txtback);
    Writeln(fil, 'STATCLR=',statclr);
    Writeln(fil, 'STATBACK=',statbak);
    Writeln(fil, 'INITSTRG=',initstrg); { 2.0e }
    Writeln(fil, 'DIALSTRG=',dialstrg); { 2.0n }
    Writeln(fil, 'VIDEOCHC=',videochc); { 2.0q }
    WriteLn(fil, 'USEANSI=',ansidef);   {2.23}
    {Writeln(fil, 'CPUSPEED=',cpuspeed);} { 2.15 }
    Close(fil);
  END;

  PROCEDURE ReadConfig;    { 2.0s }
  VAR fil : Text; srcline : Str90; { 2.0s }

   FUNCTION ParsedLine: Str90;
   VAR startl,endl: Integer; result: Str90;
    BEGIN
     startl := 0; { 2.0s }
     readln(fil, srcline);
     startl := POS('=',srcline);        
     endl := length(srcline)-(startl);
     IF (startl <> 0) AND (srcline[1] <> 'A') THEN { 2.0s }
      result := Copy(srcline,startl+1,endl)  {2.16}
     ELSE
      result := srcline;
     parsedline := result;
   END;
  
   BEGIN
    Assign(fil, 'TMODEM.CFG');
    {$I-} Reset(fil); {$I+}
    IF IORESULT = 0 THEN
     BEGIN
      cport := parsedline;
      speed := parsedline;
      scrmode := value(parsedline); { 2.0s }
      txtclr  := value(parsedline);
      txtback := value(parsedline);
      statclr := value(parsedline);
      statbak := value(parsedline);
      initstrg := parsedline;
      dialstrg := parsedline; { 2.0n }
      videochc := parsedline; { 2.0q }
      ansidef  := parsedline; {2.23}
      Close(fil);
      IF cport = 'COM1:' THEN
       COMport := 1
      ELSE
       IF cport = 'COM2:' THEN
        COMport := 2
       ELSE
        IF cport = 'COM3:' THEN
         COMport := 3
        ELSE
         IF cport = 'COM4:' THEN
          COMport := 4;
      IF speed = '2400' THEN
       baudrate := '2'
      ELSE
       IF speed = '1200' THEN
        baudrate := '1'
       ELSE
        IF speed = '9600' THEN
         baudrate := '9'
        ELSE
         IF speed = ' 300' THEN
          baudrate := '3'
         ELSE
          IF speed = '4800' THEN
           baudrate := '4'
          ELSE
           IF speed = '19200' THEN {2.23}
            baudrate := '8';
      IF videochc = 'BIOS' THEN { 2.0q }
       biosvideo := True
      ELSE
       biosvideo := False;
      IF ansidef = 'YES' THEN {2.23}
       useansi := True
      ELSE
       useansi := False;
     END
    ELSE
     BEGIN
      {$I-} Close(fil); {$I+}
      err := IORESULT;
      MakeConfig;
     END;
  END;

  PROCEDURE Initialize;          { 1.1  major changes to support window }
  VAR done : Boolean;
  BEGIN
   done := False;
   mcol := WhereX; mrow := WhereY;
   OpenW(30,12,79,24); { 2.25}
   REPEAT
    REPEAT
      GotoXY(3,2);
      Write('Bps: 3)00 1)200 2)400 4)800 9)600 8)19.2:'); {2.23}
      baudrate := Readkey;
    UNTIL baudrate IN ['1', '2', '3', '4', '9','8']; {2.23}
    Writeln;
    REPEAT
      GotoXY(3,4); { 2.0n }
      Write('Port(1,2,3,4):');
      portnum := Readkey;
    UNTIL portnum IN ['1'..'4']; {2.0}

    GotoXY(3,6); { 2.0n }
    Writeln('DialString(max 32 chars)'); { 2.0n }
    GotoXY(3,7);
    Write(':');
    Readln(dialstrg);

    IF length(dialstrg) < 4 THEN dialstrg := 'ATDT'; {2.25}

    CASE portnum OF
     '1' : COMport := 1;
     '2' : COMport := 2;
     '3' : COMport := 3;
     '4' : COMport := 4;
    END;

    Xlatesetup;                              { 1.4 }
    GotoXY(3,8);  Write(cport);              { 1.4 }
    GotoXY(3,9);  Write('BAUD: ', speed);    { 1.4 }
    GotoXY(3,10); Write('DSTR: ',dialstrg);  { 2.0n }

    REPEAT
     GotoXY(3,11);
     Write('Is this correct [Y/N]?'); {2.16}
     answer := UpCase(ReadKey);  { 2.0y }
    UNTIL answer IN ['Y','N'];
    IF answer = 'Y' THEN done:= True;
   UNTIL done;

   REPEAT                          { 1.4 }
    answer := ' ';
    GotoXY(3,11);
    Write('Save settings to disk [Y/N]?');
    answer := UpCase(ReadKey);
   UNTIL answer IN ['Y', 'N'];

   IF answer = 'Y' THEN
    MakeConfig;                    { 1.4 }
   iport1;
   GetIntVec(Async_irq+8, AsyncVector);
   iport;
   Setup(baudrate);
   CloseW; { 2.16}
   GotoXY(mcol,mrow);
   {NewStatus := True;} {2.23}
   Statusline; {2.23}
  END;

  PROCEDURE InfoScr;
  BEGIN
   mcol := WhereX; mrow := WhereY;
   OpenW(20,10,60,21); { 2.0y }
   GotoXY(3,2);  Write('   ----- TModem INFO Screen -----   ');
   Gotoxy(3,4);  Write('                                    ');
   Gotoxy(3,5);  Write('      TModem is Public Domain       ');
   Gotoxy(3,6);  Write('      Version ',version,'     ');       { 2.0g }
   Gotoxy(3,7);  Write('        Mods by L.B. Neal.          ');
   Gotoxy(3,8);  Write('                                    ');
   Gotoxy(3,9);  Write('                                    ');
   Gotoxy(3,10); Write('                                    ');
   Gotoxy(3,11); Write('  <Hit a key to return to terminal> '); {2.16}
   REPEAT UNTIL Keypressed;
   junk := Readkey; { 2.0o }
   CloseW; { 2.0y }
   GotoXY(mcol,mrow);
  END;

  FUNCTION Dial(PhoneNumber : PhoneStr) : Char;   { 1.5 major changes }
  VAR c, ch: Char; t: real; told: boolean;
  BEGIN
    told := False;
    GotoXY(1,1);
    Writeln;
    Writeln('Dialing: ',phonename,' at ',speed,' bps Number:', PhoneNumber); {2.24}
    SetDTR;
    {delay(500);} {2.23}
    sendtext(dialstrg+PhoneNumber+cr); {2.0n }
    writeln;
    {delay(500);} {2.23}
    c := cinkey;
    c := Chr(0);
    REPEAT
     c := cinkey
    UNTIL (c = cr) OR (c = 'C');
    IF (c <> 'C') THEN
     BEGIN        { timing NOT speed needed here }
      Writeln('Waiting for carrier.....<Hit "A" to abort>'); { 2.0q }
      Writeln; { 2.0s }
      t := 180*6500; { was 120*6500 - 2.0h }
      REPEAT
       t := t-1;
       IF cdet AND (NOT told) THEN { 2.0s }
         BEGIN
          Writeln('Carrier Detected!');
          writeln;
          mcol := WhereX; mrow := WhereY;
          statusline;
          told := True;
         END;
       IF commpressed THEN c := cinkey;
       IF keypressed THEN ch := ReadKey ELSE ch := ' '; { 2.0q }
       IF (ch = 'A') OR (ch = 'a') THEN
        BEGIN Writeln('Aborting!'); sendtext(cr); t := 0; END;
      UNTIL (c = 'C') OR (t < 1) OR (c = 'B') OR (c = 'N') OR
            (c = '1') OR (c = '5') OR (c = '7') OR (c = '3');
     END;
    CASE c OF  { 1.6 }
     'C' : BEGIN write(c); c := 'G'; END;
     'B' : BEGIN write(c); c := 'G'; END;
     'N' : BEGIN write(c); c := 'G'; END;
     '1' : BEGIN write('CONNECT 300 or 2400'); c := 'G'; END;
     '3' : BEGIN writeln('NO CARRIER'); c := 'G'; END;
     '5' : BEGIN writeln('CONNECT 1200'); c := 'G'; END;
     '7' : BEGIN writeln('BUSY'); c := 'G'; END;
    END;
    IF (t = 0) AND (c <> 'G') THEN c := '9';
    IF NOT cdet THEN
     BEGIN mcol := WhereX; mrow := WhereY; statusline; END; { 2.0s }
    Dial := c
  END;

  PROCEDURE GetProtocol;
  VAR Protocol : String[2];
   BEGIN
    protocol := ''; meth := 'Q';
    mcol := WhereX; mrow := WhereY;
    OpenW(56,2,78,24); { 2.16} 
    {WinBorder(58,3,80,24,B1);} { 2.0w }
    GotoXY(3,2);  Write('- Protocols -');
    GotoXY(3,4);  Write('S)uperk');
    GotoXY(3,5);  Write('J)modem');
    GotoXY(3,6);  Write('P)uma');  { 2.0x }
    GotoXY(3,7);  Write('Z)modem');
    GotoXY(3,8);  Write('B)imodem');
    GotoXY(3,9);  Write('L)ynx');
    GotoXY(3,10);  Write('M)egalink');
    GotoXY(3,11);  Write('Y)modem-1k');
    GotoXY(3,12);  Write('T)rueYmodem');
    GotoXY(3,13);  Write('W)xmodem');
    GotoXY(3,14);  Write('K)ermit');
    GotoXY(3,15); Write('C)rcXmodem');
    GotoXY(3,16); Write('X)modem');
    GotoXY(3,17); Write('A)bort');
    GotoXY(3,21); Write('Selection:');
    Readln(protocol);
    CloseW; { 2.0y }
    IF protocol = '' THEN protocol := 'A'; { 2.0r }
    protocol := upcase(protocol[1]); { 2.0r }
    IF protocol = 'C' THEN protocol := 'X'; { 2.0n }
    IF (protocol = '') OR (protocol = 'A') THEN
     BEGIN
      meth := 'Q'
     END
    ELSE
     Meth := protocol[1]; { 2.0r }
   END;

  PROCEDURE SendFile; { 2.0c }
  VAR fname:Filename;
   BEGIN
    mcol := WhereX; mrow := WhereY;
    OpenW(20,12,60,14); { 2.0y }
    GotoXY(3,2); Write('File to Upload:');
    ReadLn(fname);
    CloseW; { 2.0y }
    IF fname = '' THEN
      GotoXY(mcol,mrow)
    ELSE
     BEGIN
      way := 'S';
      GotoXY(mcol,mrow);
      GetProtocol;
      IF  meth <> 'Q' THEN
       BEGIN
        {IF useansi THEN Windo(1,1,80,25) ELSE} Windo(1,1,80,24);{2.23}
        ClrScr;
        GotoXY(1,1);
        FileShell(fname, meth, way);
        CloseW; { 2.0y }
       END
      ELSE
       BEGIN
        GotoXY(mcol,mrow);
       END;
     END;
   statusline;
  END;

  PROCEDURE RcvFile; { 2.0c }
   VAR fname: Filename;
   BEGIN
    mcol := WhereX; mrow := WhereY;
    OpenW(20,12,60,14); { 2.0y }
    GotoXY(3,2);  Write('File to Download:');
    ReadLn(fname);
    CloseW; { 2.0y }
    IF fname = '' THEN
      GotoXY(mcol,mrow)
    ELSE
     BEGIN
      way := 'R';
      GotoXY(mcol,mrow);
      GetProtocol;
      IF  meth <> 'Q' THEN
       BEGIN
        {IF useansi THEN Windo(1,1,80,25) ELSE} Windo(1,1,80,24); {2.23}
        ClrScr;
        GoToXY(1,1);
        FileShell(fname, meth, way);
        CloseW;
       END
      ELSE
       BEGIN
        GotoXY(mcol,mrow);
       END;
     END;
    Statusline;
   END;

  PROCEDURE statusline; {Changed 2.23}
  BEGIN
   IF useansi THEN ansistat := ' On' ELSE ansistat := 'Off'; { 2.0j }
   Windo(1,25,80,25); {2.23}
   TextColor(statclr); TextBackground(statbak);
   Clrscr; { 1.4 }
   IF cdet THEN
    BEGIN
     online := True;
     Write(' TModem ',version,'<HOME> for Help!Online  ANSI ',ansistat,'bps '+speed+'Port '+cport)
     END
   ELSE
    BEGIN
     online := False;
     Write(' TModem ',version,'<HOME> for Help!Offline ANSI ',ansistat,'bps '+speed+'Port '+cport);
    END;
   {Newstatus := False;} {2.23}
   Windo(1,1,80,24);{2.23}
   TextColor(txtclr);
   TextBackground(txtback);
   GotoXY(mcol,mrow);
  END;

  PROCEDURE ChangeScr;  { 2.0t }
  VAR oldscrmode : Integer; videotype : Char; { 2.0t }
  BEGIN
   oldscrmode := scrmode;
   mcol := WhereX; mrow := WhereY;
   OpenW(38,12,78,23); { 2.16 }
   GotoXY(3,2);
   Write('D)irect or B)ios Video:'); { 2.0t }
   REPEAT
    videotype := Upcase(ReadKey);
   UNTIL videotype IN ['D','B'];
   IF videotype = 'D' THEN videochc := 'DIRECT' ELSE videochc := 'BIOS';
   IF videochc = 'BIOS' THEN biosvideo := True ELSE biosvideo := False;
   GoToXY(3,3);   
   Write('Screen Color(3), B/W(2), Mono(7):'); { 2.0d }
   Read(scrnmode); { 2.0y }
   IF scrnmode = '7' THEN
    scrmode := 7
   ELSE
    IF scrnmode = '2' THEN
     scrmode := 2
    ELSE
     IF scrnmode = '3' THEN
      scrmode := 3;
   GotoXY(3,4);
   Write('Text Color(0-15)[<cr> = keep]:');
   Readln(txtcolor);
   IF txtcolor <> '' THEN txtclr := Value(txtcolor);
   GotoXY(3,5);
   Write('Backgrnd Color(0-7)[<cr> = keep]:');
   Readln(backcolor);
   IF backcolor <> '' THEN
    IF value(backcolor) <> txtclr THEN txtback := Value(backcolor);
   GotoXY(3,6);
   Write('Stat Text Color(0-15)[<cr> = keep]:');
   Readln(txtcolor);
   IF txtcolor <> '' THEN statclr := Value(txtcolor);
   GotoXY(3,7);
   Write('Stat Bkgrnd Color(0-7)[<cr> = keep]:');
   Readln(backcolor);
   IF backcolor <> '' THEN
    IF value(backcolor) <> statclr THEN statbak := Value(backcolor);
   REPEAT           { 1.4 }
    answer := ' ';  { 1.6 }
    GotoXY(3,11);
    Write('Save settings to disk [Y/N]?');
    answer := UpCase(ReadKey);
   UNTIL answer IN ['Y', 'N'];
   IF answer = 'Y' THEN MakeConfig;     { 1.4 }
   CloseW; { 2.0y }
   {IF useansi THEN Windo(1,1,80,25) ELSE} Windo(1,1,80,24); {2.23}
   TextColor(txtclr);
   TextBackground(txtback);
   IF NOT biosvideo THEN DirectVideo := True; CheckSnow := False;
   IF scrmode <> oldscrmode THEN
    BEGIN
     {TextMode(scrmode); 2.23}
     IF NOT biosvideo THEN DirectVideo := True; CheckSnow := False; { 2.0q }
     newscr := True;
    END
   ELSE
    GotoXY(mcol,mrow);
   {Newstatus := True;}          {2.23}
   Statusline; {2.23}
  END;

  FUNCTION ReadPhoneList : Integer;
  BEGIN
    Assign(PhoneFile, 'TMODEM.PHN');       { 1.5 }
    index := 0;
    {$I-} Reset(PhoneFile); {$I+}
    IF IOResult = 0 THEN
     BEGIN
      WHILE (NOT EoF(PhoneFile)) AND (index < 21) DO { 2.0f }
       BEGIN
        index := index+1;
        ReadLn(PhoneFile, PhoneList[index]);
       END;
      Close(PhoneFile);
     END;
    ReadPhoneList := index;
   {$I-} Close(PhoneFile);{$I+}
   err := IORESULT;
  END;

  PROCEDURE Add2PhoneLst;                 { 1.5 }
  VAR index,ln: Integer; fname,fnum: PhoneStr; fspeed: Char;
      done,waslist: Boolean; phoneline: PhoneEntry;
  BEGIN
   Assign(PhoneFile, 'TMODEM.PHN');       { 1.5 }
   done := False; exitphone := False; { 2.0e }
   index := 0;
   pnumbers := index;
   waslist := False;
   {$I-} Reset(PhoneFile); {$I+}
   IF IOResult = 0 THEN
    BEGIN
     waslist := True;
     ln := 3;
     GotoXY(3,ln);
     WHILE (NOT EoF(PhoneFile))  DO
      BEGIN
       index := index+1;
       ReadLn(PhoneFile, PhoneList[index]);
       INC(ln); {2.23}
       GotoXY(3,ln);
       Pnumbers := Index;
      END;
     Close(PhoneFile);
    END;
    BEGIN
     REPEAT
      IF (NOT waslist) THEN
       BEGIN
        GotoXY(3,3);
        ln := 3;
       END
      ELSE
       ln := whereY;
      Gotoxy(3,4);  Write('                                    ');
      Gotoxy(3,5);  Write('                                    ');
      Gotoxy(3,6);  Write('                                    ');
      Gotoxy(3,7);  Write('                                    ');
      GotoXY(3,4);  ln := 4;
      Writeln('Enter information or <CR> to quit!');
      INC(ln); {2.23}
      GotoXY(3,ln);
      Write('Name:');
      readln(fname);
      ln := ln+1;
      IF length(fname) > 1 THEN
       BEGIN
        INC(index); {2.23}
        pnumbers := index;
        phoneline := ' ';
        GotoXY(3,ln);  INC(ln); {2.23}
        Write('PHONE#:'); readln(fnum);
        GotoXY(3,ln); ln := ln+1;
        Write('3)00 1)200 2)400 4)800 9)600 8)19200:'); {2.23}
        readln(fspeed);
        phoneline := fname;
        phoneline := phoneline+'. '+fnum;
        REPEAT
          phoneline := phoneline+' ';
        UNTIL length(phoneline) = 32;
        phoneline[32] := fspeed;
        Phonelist[index] := phoneline;
        done := True;
       END
      ELSE
       BEGIN
        done := True;
        exitphone := True; { 2.0e }
       END;
     UNTIL done;
    END;
   {$I-} Close(PhoneFile); {$I+}
   err := IORESULT;
  END;

  PROCEDURE SavePhoneLst;                 { 1.5 }
  BEGIN
   Assign(PhoneFile, 'TMODEM.PHN');       { 1.5 }
   index := 0;

   {$I-} Rewrite(PhoneFile); {$I+}
   err := IORESULT;
   Close(phonefile);

   {$I-} Reset(PhoneFile); {$I+}
   IF IOResult = 0 THEN
    BEGIN
   {$I-} Append(PhoneFile); {$I+}
     WHILE (index < pnumbers) DO
      BEGIN
       index := index+1;
       WriteLn(PhoneFile, PhoneList[index]);
      END;
    END;
   {$I-} Close(PhoneFile); {$I+}
   err := IORESULT;
  END;

  PROCEDURE Call;
  VAR rc : String[2]; selection, i, j, k : Integer; PhoneNo : PhoneStr;
      ans : Char; cdone : boolean; lrow, lcol : Integer; { 2.0f }
  BEGIN
    N_Phones := ReadPhoneList;
    IF N_Phones > 0 THEN
     BEGIN
      mcol := WhereX; mrow := WhereY;
      OpenW(39,1,79,24);
      Cdone := False;
      lcol := 3;
      lrow := 2;
      GotoXy(lcol,lrow); {2.0f}
      FOR i := 1 TO N_Phones DO
      BEGIN
       Writeln(Chr(i+64), ' - ', PhoneList[i]);
       INC(lrow); GotoXY(lcol,lrow);
      END;
      Selection := 0;
      GotoXY(lcol,21);
      Write('Item to Dial or <CR> to EXIT:'); { 2.0m }
      REPEAT
       Readln(rc);
       ans := rc[1];
       ans := UpCase(ans);
       IF (rc = '') THEN
        cdone := True        { 1.5 }
       ELSE
        selection := Ord(ans)-Ord('@');
      UNTIL (selection IN [1..N_Phones]) OR cdone;
      CloseW; { 2.0y }
      IF (NOT cdone) AND (PhoneList[selection][32] > #48) THEN { 2.0h }
       BEGIN
        ClrScr; { 2.0p }
        baudrate := PhoneList[selection][32];
        Setup(baudrate);
        StatusLine; { 2.0i }
        j := 30;
        PhoneNo := '';
        WHILE PhoneList[selection][j] <> '.' DO
         j := j-1;
        phonename := Copy(phonelist[selection],1,j-1); { 2.16 }
        FOR k := j+1 TO 30 DO { 2.0f }
        PhoneNo := PhoneNo+PhoneList[selection][k];
        rc := Dial(PhoneNo);
       END
      ELSE
        GotoXY(mcol,mrow);
     END;
  END;

  PROCEDURE ChangePhoneLst;
  VAR rc: String[2]; selection,i,j,k: Integer; PhoneNo: PhoneStr;
      ans: Char; cdone: boolean; lrow: Integer; {2.23}
  BEGIN
    N_Phones := ReadPhoneList;
    pnumbers := index; { 2.0h }
    IF N_Phones > 0 THEN
     BEGIN
      Cdone := False;
      lrow := 2;
      GotoXy(3,lrow); {2.23}
      FOR i := 1 TO N_Phones DO
       BEGIN
        Writeln(Chr(i+64), ' - ', PhoneList[i]);
        INC(lrow);
        GotoXY(3,lrow); {2.23}
       END;
      Selection := 0;
      INC(lrow);      {2.23}
      GotoXY(3,lrow); {2.23}
      Write('Item to Change or <CR> to EXIT:'); { 2.23}
      REPEAT
       Readln(rc);
       ans := rc[1];
       ans := UpCase(ans);
       IF (rc = '') THEN
        cdone := True        { 1.5 }
       ELSE
        selection := Ord(ans)-Ord('@');
      UNTIL (selection IN [1..N_Phones]) OR cdone;

      IF (NOT cdone) AND (PhoneList[selection][32] > #48) THEN
       BEGIN
        baudrate := PhoneList[selection][32];
        j := 30;
        PhoneNo := '';
        WHILE PhoneList[selection][j] <> '.' DO
         j := j-1;
        phonename := Copy(phonelist[selection],1,j-1); { 2.16 }
        FOR k := j+1 TO 30 DO { 2.0f }
         PhoneNo := PhoneNo+PhoneList[selection][k];
       END;

      IF NOT cdone THEN
       BEGIN
        INC(lrow); {2.23}
        GotoXY(3,lrow);
        Write('Name Or <CR> to clear:'); Readln(phonename);
        IF phonename <> '' THEN
         BEGIN
          INC(lrow); {2.23}
          GotoXY(3,lrow); {2.23}
          Write('Phone#:'); Readln(PhoneNo);
          GotoXY(3,lrow+1); {2.23}
          Write('Bps 3)00 1)200 2)400 4)800 9)600 8)19.2k:'); {2.23}
          Read(baudrate);
          PhoneList[Selection] := PhoneName+'. '+PhoneNo;
          While length(phonelist[selection]) < 31 DO
           PhoneList[selection] := Phonelist[selection]+' ';
          PhoneList[selection] := Phonelist[selection]+baudrate;
          SavePhoneLst;
         END
        ELSE
         BEGIN
          PhoneList[selection] := ' ';
           While length(phonelist[selection]) < 32 DO
          PhoneList[selection] := PhoneList[selection]+' ';
          SavePhoneLst;
         END;
       END;
      {CloseW;} {2.23}
      {GotoXY(mcol,mrow);} {2.23}
     END
    ELSE
     clrscr;
     {GotoXY(mcol,mrow);} {2.23}
  END;

  PROCEDURE UsePhone;          { 1.5 }
  VAR ddone : Boolean;
  BEGIN
   ddone := False;
   REPEAT
    REPEAT
     GotoXY(3,4);
     Write('A)ddToLst, C)hangeLst, Q)uit, <CR> To Dial:'); {2.23}
     answer := upcase(ReadKey); { 2.0y }
    UNTIL answer IN ['A','C','Q',#13]; { 2.23}
    IF answer = #13 THEN answer := 'D'; {2.23}
    IF answer = 'D' THEN {2.23}
     BEGIN
      Ddone := True;
      Callout := True;
     END
    ELSE
     IF answer = 'A'THEN
      BEGIN
       Add2PhoneLst;
       IF exitphone THEN BEGIN ddone := True; exitphone := False; END; { 2.0e }
       Callout := True; { 2.0h }
      END
     ELSE
      IF answer = 'Q' THEN
       BEGIN
        ddone := True;
        savescrn := True;  { 2.0p }
       END
      ELSE
       IF answer = 'C' THEN
        BEGIN
         ChangePhoneLst; { 2.0h }
         ddone := True;
         Callout := True; { 2.0h }
        END;
    IF (NOT ddone) THEN
     BEGIN
      REPEAT
       answer := ' ';
       Gotoxy(3,11); Write('                                    ');
       GotoXY(3,11);
       Write('Save settings to disk [Y/N]?');
       answer := UpCase(ReadKey);
      UNTIL answer IN ['Y', 'N'];
      IF answer = 'Y' THEN
       BEGIN
        SavePhoneLst;
        ddone := True; { 2.0e }
       END;
      ddone := True; { 2.0e }
     END;
   UNTIL ddone;
  END;

  PROCEDURE DialMenu;       { 1.5 }
  BEGIN
   mcol := WhereX; mrow := WhereY;
   OpenW(30,8,79,24); {2.23}
   GotoXY(3,2);  Write('   ----- TModem Dialing Menu -----  ');
   Gotoxy(3,4);  Write('                                    ');
   Gotoxy(3,5);  Write('                                    ');
   Gotoxy(3,6);  Write('                                    ');
   Gotoxy(3,7);  Write('                                    ');
   Gotoxy(3,8);  Write('                                    ');
   Gotoxy(3,9);  Write('                                    ');
   Gotoxy(3,10); Write('                                    ');
   Gotoxy(3,11); Write('                                    ');
   UsePhone;
   CloseW; { 2.16 }
   GotoXY(mcol,mrow);
  END;

 PROCEDURE SetMacros; { 2.0i }
 VAR mfile: Text; dmac: MacStr; mnum: String[2]; index: Integer;
  BEGIN
   index := 1;
   Assign(mfile,'TMODEM.MAC');
   {$I-} Reset(mfile); {$I+}
   IF IORESULT = 0 THEN
    BEGIN
     WHILE NOT EOF(mfile) DO
      BEGIN
       Readln(mfile,dmac);
       MacArray[index] := dmac;
       INC(index);
      END;
    END
   ELSE
    BEGIN
     FOR index := 1 TO 10 DO
      BEGIN
       IF index < 10 THEN
        mnum := chr(index+48)
       ELSE
        mnum := '10';
       MacArray[index] := 'This is Macro'+mnum;
      END;
    END;
  END;

(* -----------------------------------------------
   This Procedure is NOT used! Left in as example!

 PROCEDURE WriteDos(VAR letter: Char); { 2.0i }
 VAR regs : Registers;
  BEGIN
   WITH regs DO
    BEGIN
     AH := 2;
     DL := ord(letter);
    END;
   MSDOS(regs);
  END;
 ----------------------------------------------- *)

   FUNCTION TmodemExit:Boolean;
   VAR ans: Char;
   BEGIN
    mcol := WhereX; mrow := WhereY; { 2.0p }
    OpenW(25,12,50,14); { 2.0y }
    GotoXy(3,2); { 2.0f }
    Write(' Exit TModem [Y/N]?'); { 2.16 }
    ans := UpCase(Readkey);
    IF ans = 'Y' THEN
     BEGIN
      TmodemExit := True;
      CloseW;
     END
    ELSE
     BEGIN
      CloseW;
      TmodemExit := False;
      GotoXY(mcol,mrow);
     END;
   END;

 {$B-}
  PROCEDURE terminal;
  VAR c,tinkey: char; {2.23}
  BEGIN
  {------- This is the main loop must be faaassst! ----------}
   REPEAT
    IF online THEN
     BEGIN  {2.23}
      IF (port[cdetport] AND 128) = 0 THEN {2.23}
       BEGIN
        mcol := WhereX; mrow := WhereY; {2.23 added}
        Statusline; {1.05y}
       END;
     END;
    IF NOT shown THEN
     BEGIN
      IF (port[cdetport] AND 128) <> 0 THEN {2.23}
       BEGIN
        mcol := WhereX; mrow := WhereY; {2.23 added}
        statusline;
        shown := true;
       END;
     END;
    IF Callout THEN { 1.5 }
     BEGIN
      callout := False;
      shown := False;   { 2.0t }
      call;             { call the selected number }
     END;

{------------------ the power loop here -----------------}
    REPEAT
     IF Inready THEN
      BEGIN
       inline($FA);
       tinkey := RecBuf[buffer_Tail];
       IF Buffer_Tail < Buffer_End THEN INC(Buffer_Tail) ELSE Buffer_Tail := 1;
       DEC(buffer_count);
       IF Buffer_Count = 0 THEN Inready := False; {2.17}
       inline($FB);
       Port[$20] := $20; {2.19}
       IF tinkey = #27 THEN {2.23}
        BEGIN
         IF useansi THEN Put_Ansi ELSE Write(tinkey);
        END
       ELSE
        BEGIN
         CASE tinkey OF {2.23}
          #12: ClrScr;  {2.23}
           #8: Write(#8,#32,#8);                            {2.23}
         ELSE
          IF tinkey > #8 THEN Write(tinkey)                 {2.23}
         END;{case}
        END;
      END;
    UNTIL NOT Inready {OR Keypressed};   {2.23 to avoid char loss}

    IF KeyPressed THEN {2.19}
     BEGIN
      mcol := WhereX; mrow := WhereY; {2.22 Moved here}
      c := ReadKey;                         { 2.0y }
      {Below needs work 2.23}
      IF c <> #0 THEN {2.23}
       Port[base] := Ord(c)
      ELSE
      IF {(c = #0) AND} KeyPressed THEN {2.23}
       BEGIN
        c := ReadKey;
        DEC(mcol); {put cursor back where it belongs}
        CASE c OF
         #71 : termscrn;   { 1.1 Home = Help }
         #73 : Sendfile;   { 1.1 PgUp = Upload }
         #81 : Rcvfile;    { 1.1 PgDn = Download }
         #35 : HangItUp;   { 1.1 ALT-H = HangupPhone }
         #24 : Initialize; { 1.1 ALT-O = Options }
         #19 : ResetModem; { ALT-R Reset Modem 2.23 }
         #45 : Done := TmodemExit; { ALT-X = Exit Terminal 2.0y }
         #23 : InfoScr;    { ALT-I = Info Screen }
         #31 : ChangeScr;  { ALT-S = Change Screen  1.1 }
         #32 : DialMenu;   { ALT-D = dialing menu 1.5 }
         #36 : JumpDos;    { ALT-J = JumpDos 2.0c }
         #46 : BEGIN ClrScr; StatusLine; END; { ALT-C = clearscreen 2.0J }
         #59 : SendStr(MacArray[1]+cr); { F1 = Macro1 } { 2.0i }
         #60 : SendStr(MacArray[2]+cr); { F2 = Macro1 }
         #61 : SendStr(MacArray[3]+cr); { F3 = Macro1 }
         #62 : SendStr(MacArray[4]+cr); { F4 = Macro1 }
         #63 : SendStr(MacArray[5]+cr); { F5 = Macro1 }
         #64 : SendStr(MacArray[6]+cr); { F6 = Macro1 }
         #65 : SendStr(MacArray[7]+cr); { F7 = Macro1 }
         #66 : SendStr(MacArray[8]+cr); { F8 = Macro1 }
         #67 : SendStr(MacArray[9]+cr); { F9 = Macro1 }
         #68 : SendStr(MacArray[10]+cr); { F10 = Macro1 }
         #30 : BEGIN { ALT-A Toggle ANSI mode 2.0l }
                UseAnsi := NOT UseAnsi;
                {IF useansi THEN Windo(1,1,80,25) ELSE} Windo(1,1,80,24);{2.23}
                Clrscr; newscr := True; 
                statusline; { 2.0s }
               END;
         #47 : BEGIN mcol := WhereX; mrow := WhereY; StatusLine; END; { ALT-V view StatusLine 2.0m }
        END;
        IF newscr THEN BEGIN GoToXY(1,1); NewScr := False; END; { 2.0h }
       END;
     END;
   UNTIL done;
  END;
 {$B+}

 BEGIN  {TModem}
  WindInit; { 2.16 }
  oldmode := 2;   { 2.13 }
  IF mem[$0000:$0449] = 7 THEN
   BEGIN
    {TextMode(Mono);} {2.23}
    oldmode := 7;
    scrmode := 7; { 2.0o }
   END
  ELSE
   BEGIN
    {Textmode(CO80);} {2.23}
    oldmode := 3;  scrmode := 3;
   END;
  biosvideo := True; { 2.0q }
  DirectVideo := False; CheckSnow := False; CheckBreak := False; { 2.0q }
  MEMW[$0040:0004] := $03E8; {2.17 COM3: for DOS}
  MEMW[$0040:0006] := $02E8; {2.17 COM4: for DOS}
  callout := False;
  shown := False;     { 2.0t }
  useansi := False;   { 2.0j }
  done := False;      { 1.1 }
  {andwith := 255;}     { allow full IBM ASCII set 2.0} {2.19 gone}
  online := False;    { 2.0v }
  Delay(200);         {Force calibrate delay 2.21}
  Assign(cfile, 'TMODEM.CFG');
  {$I-} Reset(cfile); {$I+}
  IF IORESULT = 0 THEN
   BEGIN
    Close(cfile); { 1.5 }
    ReadConfig;
   END
  ELSE
   BEGIN
    {$I-} Close(cfile); {$I+}
    err := IORESULT;
    Writeln('TModem.cfg was NOT found! Building the file.'); { 2.0o }
    Delay(1000); { 2.0u }
    COMport := 1;
    baudrate := '2'; { 2.19  2400 baud}
    txtclr := 15;
    IF scrmode = 3 THEN {2.22}
     BEGIN
      txtback := 1;
      statbak := 4;
      statclr := 14;
     END
    ELSE
     BEGIN
      txtback := 0;
      statbak := 1;
      statclr := 0;
     END;
    initstrg := 'AT &C1 &D2 X4 S0=0 M0'; { 2.0e }
    dialstrg := 'ATDT';                   { 2.0n }
    videochc := 'BIOS';  { 2.0q }
    MakeConfig;          { 1.4 }
   END;
  {Newstatus := True;} {2.23}
  NewScr := False;     { 1.4 }
  mcol := 1;           { 1.6 }
  mrow := 1;           { 1.6 }
  {TextMode(scrmode);} {2.23}
  TextColor(txtclr);
  TextBackground(txtback);
  IF NOT biosvideo THEN DirectVideo := True;
  CheckSnow := False; { 2.0q }
  Windo(1,25,80,25);         {2.23}
  TextColor(statclr);
  TextBackground(statbak);
  clrscr;
  Windo(1,1,80,24);         {2.23}
  TextColor(txtclr);
  TextBackground(txtback);
  clrscr;
  XlateSetup; { 2.0i }
  writeln('TModem Terminal Mode! Using ',videochc,' screenwrites.');
  {mcol := WhereX; mrow := WhereY;} {2.23}
  iport1; {ok}
  GetIntVec(Async_irq+8, AsyncVector);
  iport;
  init1;
  ResetModem;  { 2.0b }
  SetMacros;   { 2.Oi }
  {delay(500);}  { 2.23 }
  mcol := WhereX; mrow := WhereY; {2.23}
  Statusline;  {2.23}
  Terminal;    { 1.1  this is the main loop for TModem }
  remove_port;
  delay(500); { 2.15 }
  SetIntVec(Async_irq+8,AsyncVector);
  NormVideo;
  DirectVideo := False; {2.13}
  Window(1,1,80,25);    { 1.1 }
  ClrScr;
(* -----   2.23
  CASE oldmode OF       { 2.13 }
   7 : textmode(mono);
   3 : textmode(CO80);
   2 : textmode(BW80);
  END;
  DirectVideo := False; {2.13}
  NormVideo; {2.13}
  Write(' '); {2.13}
  ClrScr;
 --------------- *)
 END.
